<?php
/*
    arbre.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Frdric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/***********************************************************

"Vision globale de l'arbre" dans le menu de la partie administration

page permettant de visualiser sommairement l'arborescence nareto 

***********************************************************/

include ("../include/top.php");

/***********************************************************/
// on verifie que l'utilisateur a l'autorisation de parcourir la page
// si ce n'est pas le cas on le redirige sur la page d'accueil
/***********************************************************/

if (_CONTACT != _ADMIN) {
	if (!is_auto(4)) {?>
		<script language="JavaScript" type="text/javascript">
			document.location = '../index.php';
		</script>
	<?}
}

echo lang("Vision globale de l'arbre")."<br><br>";

/***********************************************************/
// affiche les services associes au noeud pass en argument 
// le rang sert a l'indentation des informations
/***********************************************************/

function affiche_arbo_services($boite, $rang) {
	$space = "";
	for ($i=0;$i<$rang;$i++) {
		$space .= "--";
	}
	$req = "select S.name, LBS.alias from l_boite_services as LBS inner join services as S where LBS.id_boite='".$boite."' and S.id=LBS.id_services";
	$res = mysql_query($req) or die("Selection des services associs au noeud courant dans arbre");
	while ($row = mysql_fetch_array($res)) {
		if ($row["alias"] != "") {
			$alias = " (".$row["alias"].")";
		} else { $alias = ""; }
		echo $space.$row["name"].$alias."<br>";
	}
}

/***********************************************************/
// fonction principale de la page
// affiche les noeuds du niveau 0 et recupere ses enfants et les services associes
/***********************************************************/

function affiche_arbo($boite, $rang) {
	$space = "";
	for ($i=0;$i<$rang;$i++) {
		$space .= "--";
	}
	$req = "select * from boite where parent='".$boite."'";
	$res = mysql_query($req) or die("Selection des enfants de la boite courante dans arbre");
	while ($row = mysql_fetch_array($res)) {
		echo $space.$row["name"]."<br>";
		affiche_arbo_services($row["id"], $rang+1);
		affiche_arbo($row["id"], $rang+1);
	}
}

affiche_arbo(0, 0);

include ("../include/bottom.php");
?>