<?php
/*
    alert_export.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Frdric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	
	include ("../include/config.php");
	
	extract ($_GET, EXTR_OVERWRITE);
	
	header ( "Expires: 0" ) ;
	header ( "Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT" ) ;
	header ( "Content-type: octet-stream" ) ;
	header ( "Content-Disposition: inline; filename=alert_".$choix_boite.".csv" ) ;

extract($_POST, EXTR_OVERWRITE);
extract($_GET, EXTR_OVERWRITE);


if (!isset($choix_boite)) {
  $choix_boite = 0;
}

if (!isset($dateDebut)) {
  $date1 = date("Y-m-d H:i", time() - 24*60*60);
} else {
  $date1 = $dateDebut;
}
if (!isset($dateFin)) {
  $date2 = date("Y-m-d H:i");
} else {
  $date2 = $dateFin;
}

$debut_time = makeTimestampSeconde($date1, "debut");
$fin_time = makeTimestampSeconde($date2, "fin");


if (!isset($_GET["calcul"]) && !isset($_GET["crit"]) && !isset($_GET["warn"]) && !isset($_GET["unkn"])) {
$crit = 1;
$warn = 1;
$unkn = 1;
}

  $ajout_req = "";
  $ajout_lien = "";
	if ($crit == 1 || $warn == 1 || $unkn == 1) {
		$ajout_req .= " and (";
		$or = "";
		if ($crit == 1) {
			$ajout_req .= " etat='C'";
			$or = " or";
			$ajout_lien .= "&crit=1";
		}
		if ($warn == 1) {
			$ajout_req .= $or." etat='W'";
			$or = " or";
			$ajout_lien .= "&warn=1";
		}
		if ($unkn == 1) {
			$ajout_req .= $or." etat='U'";
			$or = " or";
			$ajout_lien .= "&unkn=1";
		}
		$ajout_req .= " )";
	}

$debut = $date1;
$fin = $date2;
$parent = $choix_boite;


if (!isset($_GET["order"])) {
  $order = "asc";
} else {
  $order = $_GET["order"];
}



  if (is_right($choix_boite)) {
    unset($tab_alarmes);
    $tab_alarmes = array();
    $tab_alarmes = recup_alarmes($tab_alarmes, $choix_boite, $debut_time, $fin_time);
    $req_all = "select * from suivi_semaine where timestamp<=".$fin_time." and timestamp>=".$debut_time." ";
    $count = 0;
    $total = count($tab_alarmes);
    foreach ($tab_alarmes as $alarme) {
      $count++;
      if ($count == 1) {
	$req_all .= " and (";
      }else {
	$req_all .= " or";
      }
      $req_all .= " (host='".$alarme["host"]."' and service='".$alarme["service"]."') ";
      if ($count == $total) {
	$req_all .= ") ";
      }
    }
    $req_all .= $ajout_req;
    $req_all .= " order by timestamp desc";
    $req_export = $req_all;
  }

	echo lang("Domaine").";".lang("Etat").";".lang("Date").";".lang("Host").";".lang("Service").";".lang("Status information").";".lang("Technician ack")."; \n";
	
	$res = mysql_query($req_export);
	while ($row = mysql_fetch_array($res)) {
		switch ($row["etat"]) {
			case "C" : $etat = "CRITICAL";
						break;
			case "W" : $etat = "WARNING";
						break;
			case "U" : $etat = "UNKNOWN";
						break;
			case "P" : $etat = "PENDING";
						break;
		}
		echo $domaine.";".$etat.";".date("d/m/y H:i:s",$row["timestamp"]).";".$row["host"].";".$row["service"].";".$row["commentaire"].";".$row["comm_ack"]."; \n";
	}

?>

