<?php
/*
    fonctions.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Fr�d�ric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/** 
 * fonction de traduction
 * 
 * $string = chaine a traduire
 * $source = chemin relatif ou aller chercher le fichier de lang
 */
function lang($string, $source=1) {
	$dir = "../";
	if ($source == 0) {
		$dir = "";
	}
	//$write = 0;
	//if (file_exists($dir."lang/temp.txt")) {
	//	$f = fopen($dir."lang/temp.txt", "a+");
	//	$write = 1;
	//}
	include ($dir."lang/config.php");
	include ($dir."lang/"._LANG.".txt");

	//if (!isset($trad[$string])) {
	//	if ($write == 1) {
	//		fwrite($f, $string."\n");
	//	}
	//	return $string;
	//} else {
		return $trad[$string];
	//}
	//fclose($f);
}

/**
 * fonction de gestion des droits
 * 
 * $boite = boite sur laquelle on veut connaitre les droits
 * $statut = objet sur lequel porte la recherche (boite ou service)
 */
function is_right($boite, $statut="") {
  $contacts = split( ",", _ADMIN );
  for ( $i=0; $i < count($contacts) ; $i++ ) {
    if ( _CONTACT == trim($contacts[$i]) ) { return true;}
  }
  if ( $statut != "" ) { return true;}
  $req = "select LCC.id_contactgroups from l_droits,l_contacts_contactgroups as LCC inner join contacts as C where C.name='"._CONTACT."' and LCC.id_contacts=C.id and l_droits.id_boite=".$boite." and l_droits.id_contactgroups=LCC.id_contactgroups";

  $res_droits = mysql_query($req);
  $nb = mysql_num_rows($res_droits);
  $ok = false;
  if ($nb != 0) {
    $ok = true;
  }
  
  return $ok;
}

/**
 * fonction de gestion des autorisations pour les diff�rentes parties de nareto
 * 
 * $contact = contact pour lequel on cherche les autorisations
 * $source = partie de nareto pour laquelle on cherche les autorisations
 */
function is_auto($source) {
	$ok = FALSE;
	// on recupere les contactgroups du user
	$res = mysql_query("select LCC.id_contactgroups as cg from l_contacts_contactgroups as LCC inner join contacts as C where C.name='"._CONTACT."' and LCC.id_contacts=C.id");
	while ($row = mysql_fetch_array($res)) {
		// on selectionne les autorisations du contactgroup
		$res2 = mysql_query("select * from autorisations where contactgroup='".$row["cg"]."' and partie='".$source."'");
		if (mysql_num_rows($res2)) {
			$ok = TRUE;
		}
	}
	return $ok;
}

/**
 * fonction fil_ariane
 * 
 * $source = page d'appel de la fonction (1=>TpsR, 2=>SuiAl, 3=>Rep)
 * $choix_boite = boite courante pour laquelle soit on va chercher le parent soit on affiche le nom
 * $debut = debut de la periode recherchee dans le suivi des alarmes ou dans le reporting
 * $fin = fin de la periode recherchee dans le suivi des alarmes ou dans le reporting
 */
function fil_ariane($source, $choix_boite, $debut="", $fin="", $ajout_lien="") {
	$row = mysql_fetch_array(mysql_query("select id, name, parent, alias from boite where id='".$choix_boite."'"));
	if ($row["parent"] != 0) { 
		fil_ariane($source, $row["parent"], $debut, $fin, $ajout_lien); 
	}
	if ($row[AFF_ALIAS] == "") {
		$row[AFF_ALIAS] = $row["name"];
	}
	if ($row[AFF_ALIAS] != "") {
		if ($source == 1) {
			echo "<a href=\"box.php?box_id=".$row["id"]."\">".$row[AFF_ALIAS]."</a> > ";
		} elseif ($source == 2) {
			echo "<a href=\"top_suivi.php?dateDebut=".$debut."&dateFin=".$fin."&choix_boite=".$row["id"]."\">".$row[AFF_ALIAS]."</a> > ";
		} elseif ($source == 3) {
			echo "<a href=\"dispo_box.php?id=".$row["id"]."&debut=".$debut."&fin=".$fin."\">".$row[AFF_ALIAS]."</a> > ";
		} elseif ($source == 4) {
			echo "<a href=\"index.php?dateDebut=".$debut."&dateFin=".$fin."&choix_boite=".$row["id"].$ajout_lien."\">".$row["name"]."</a> > ";
		}
	}	
}

/**
 * fonction replace_by_spaces
 * 
 * $string = chaine qu'il faut "nettoyer"
 */
function replace_by_spaces($string) {
	$string = str_replace(Array('-','_'), ' ', $string);
	$t_string = explode(" ", $string);
	$t_return = "";
	foreach ($t_string as $t_s) {
		if (strlen($t_s) > 16) {
			$nb = strlen($t_s)/16;
			for ($i=0;$i<$nb;$i++) {
				$t_return .= substr($t_s, ($i*16), 16);
				$t_return .= " ";
			}
		} else {
			$t_return .= $t_s;
		}
		$t_return .= " ";
	}
	return $t_return;
}

/*******************************************************************************
 * 							temps r�el
 ******************************************************************************/

/**
 * fonction haut_tele
 * 
 * $fond = etat du service pour afficher le fond de la tele
 */
function haut_tele($fond) { ?>
	<table cellpadding="0" cellspacing="0" border="0" style="width: 136px">
		<tr>
			<td width="9px"><img src="../img/tv/haut_gauche.gif"></td>
			<td width="118px"><img src="../img/tv/haut.gif"></td>
			<td width="9px"><img src="../img/tv/haut_droite.gif"></td>
		</tr>
		<tr>
			<td><img src="../img/tv/gauche.gif"></td>
			<td background="../img/tv/fond_<? echo $fond; ?>.gif" style="background-repeat: no-repeat">
<?
}

/**
 * fonction bas_tele
 * 
 * 
 */
function bas_tele() { ?>
			</td>
			<td><img src="../img/tv/droite.gif"></td>
		</tr>
		<tr>
			<td><img src="../img/tv/bas_gauche.gif"></td>
			<td><img src="../img/tv/bas.gif"></td>
			<td><img src="../img/tv/bas_droite.gif"></td>
		</tr>
	</table>
<?
}

/**
 * function affiche_tele_sous_boite
 * 
 * $screen = donnees de la boite ou du service a afficher
 * $css_etats = tableau des styles pour les differents etats
 * $current = id de la boite courante utilise pour le lien 
 * $compteur = nombre de boites affichees (4 par ligne max)
 */
function affiche_tele_sous_boite($screen, $css_etats, $current, $compteur) {
	$res_ack = mysql_query("select ack_comment from l_boite_services where id_boite='".$screen["id"]."'");
	$title_ack = "";
	while ($ro_ack = mysql_fetch_array($res_ack)) {
		$title_ack .= ($ro_ack["ack_comment"] != "" ? $ro_ack["ack_comment"]."\n" : "" );
	}
	haut_tele($css_etats[$screen["etat"]]); 
	if ($screen["droits"]) {
		echo "\t\t\t<a href=\"box.php?box_id=".$current."&current=".$screen["id"]."\" title=\"".$css_etats[$screen["etat"]]."\">\n";
		echo "\t\t\t\t <span class=\"boite_simple\"><span class=\"petit\">".replace_by_spaces($screen['name'])."</span></span>\n";
		echo "\t\t\t</a>\n";
	} else {
		echo "\t\t\t<a title=\"".$css_etats[$screen["etat"]]."\">\n";
		echo "\t\t\t\t <span class=\"boite_simple\"><span class=\"petit\">".replace_by_spaces($screen['name'])."</span></span>\n";
		echo "\t\t\t</a>\n";
	}
	bas_tele(); 
	$compteur++;
	if ($compteur == 4) {
		echo "</td></tr>\n<tr><td class=\"dom_area_box\">";
		$compteur = 0;
	} else {
		echo "</td>\n<td class=\"dom_area_box\">";
	}

	return $compteur;
}

function affiche_tele_sous_boite2($screen, $css_etats, $current, $compteur) {
	$res_ack = mysql_query("select ack_comment from l_boite_services where id_boite='".$screen["id"]."'");
	$title_ack = "";
	while ($ro_ack = mysql_fetch_array($res_ack)) {
		$title_ack .= ($ro_ack["ack_comment"] != "" ? $ro_ack["ack_comment"]."\n" : "" );
	}
	# haut_tele($css_etats[$screen["etat"]]);
        
        $local_etat_array = split( '_', $css_etats[$screen["etat"]]);
        
        echo '<div class="node">';
        echo "\t\t\t\t\t <div class=\"nodeName\">\n";
        
	if ($screen["droits"]) {
          echo "\t\t\t\t\t<a href=\"box.php?box_id=".$current."&current=".$screen["id"]."\" title=\"".$local_etat_array[0]."\">\n";
          echo "\t\t\t\t\t\t ".replace_by_spaces($screen['name'])."\n";
          echo "\t\t\t\t\t</a>\n";
	} else {
          echo "\t\t\t\t\t\t ".replace_by_spaces($screen['name'])."\n";
	}
        echo "\t\t\t\t\t </div>\n";

        echo "\t\t\t\t\t<div class=\"nodeState\">";
        echo '<a href="box.php?box_id='.$current."&current=".$screen["id"]."\" title=\"".$local_etat_array[0].'"><img src="../img/temps_reel/'.$local_etat_array[0].'.gif" title="'.$local_etat_array[0].'" /></a>';
        echo "</div>\n";

        echo "\t\t\t\t\t<div class=\"nodeAck\">";
        if ( $local_etat_array[1] == "ack" ) {
          echo '<img src="../img/temps_reel/ack.gif" />';
        }
        else {
          echo '<img src="../img/temps_reel/notack.gif" />';
        }
        echo "</div>\n";
        
        echo "\t\t\t\t</div>\n";
	$compteur++;

	return $compteur;
}






function affiche_tele_services2($screen, $css_etats, $compteur) {
	$row2 = mysql_fetch_array(mysql_query("select name from hosts where id=".$screen["id_hosts"]));

        echo '<div class="node">';
        echo "\t\t\t\t\t <div class=\"nodeName\">\n";

	$local_etat_array = split( '_', $css_etats[$screen["etat"]]);
        


	if (_NAGIOS == 1) {
          echo "\t\t\t\t\t<a  href='"._NAGIOS_PATH."/cgi-bin/extinfo.cgi?type=2&host=".$row2['name']."&service=".$screen["name"]."' title=\"".$local_etat_array[0]."\">\n";
	}
	echo "\t\t\t\t ".replace_by_spaces($screen["name"])."\n";
	if (_NAGIOS == 1) {
		echo "\t\t\t</a>\n";
	}
        echo "\t\t\t\t\t </div>\n";

        echo "\t\t\t\t\t<div class=\"nodeState\">";

        if (_NAGIOS == 1) {
          echo "\t\t\t\t\t<a  href='"._NAGIOS_PATH."/cgi-bin/extinfo.cgi?type=2&host=".$row2['name']."&service=".$screen["name"]."' title=\"".$local_etat_array[0]."\">\n";
	}
        echo '<img src="../img/temps_reel/'.$local_etat_array[0].'.gif" title="'.$local_etat_array[0].'" />';
        if (_NAGIOS == 1) {
		echo "\t\t\t</a>\n";
	}
        echo "</div>\n";

        echo "\t\t\t\t\t<div class=\"nodeAck\">";
        if ( $local_etat_array[1] == "ack" ) {
          echo '<img src="../img/temps_reel/ack.gif" />';
        }
        else {
          echo '<img src="../img/temps_reel/notack.gif" />';
        }
        echo "</div>\n";
        
        echo "\t\t\t\t</div>\n";
	$compteur++;
	
	
	return $compteur;
}



function affiche_tele_services($screen, $css_etats, $compteur) {
	$row2 = mysql_fetch_array(mysql_query("select name from hosts where id=".$screen["id_hosts"]));
	haut_tele($css_etats[$screen["etat"]]);
	if (_NAGIOS == 1) {
		echo "\t\t\t<a  href='"._NAGIOS_PATH."/cgi-bin/extinfo.cgi?type=2&host=".$row2['name']."&service=".$screen["name"]."' title=\"".$css_etats[$screen["etat"]]."\">\n";
	}
	echo "\t\t\t\t <span class=\"boite_simple\"><span class=\"petit\">".replace_by_spaces($screen["name"])."</span></span>\n";
	if (_NAGIOS == 1) {
		echo "\t\t\t</a>\n";
	}
	bas_tele();
	
	if (_PERFPARSE == 1) {
		echo "\t<div class=\"perfparse\">\n";
		// on recupere les contactgroups du user
		$res = mysql_query("select A.id from l_contacts_contactgroups as LCC inner join contacts as C inner join autorisations as A where C.name=\""._CONTACT."\" and LCC.id_contacts=C.id and A.contactgroup=LCC.id_contactgroups and A.partie='6'");
		if (mysql_num_rows($res)) {
			mysql_select_db(_BD_PERFPARSE, _CONNEXION);
			$res = mysql_query("select metric from perfdata_service_metric where host_name=\"".$row2['name']."\" and service_description like \"%".$screen['name']."%\"");
			while ($row_metric = mysql_fetch_array($res)) {
				echo "\t\t\t<a href='"._NAGIOS_PATH."/cgi-bin/perfparse.cgi?graph=1&host=".urlencode($row2['name'])."&service=".urlencode($screen['name'])."&metric=".urlencode($row_metric["metric"])."' class=\"lien_perfparse\">".$row_metric["metric"]."</a><br>\n";
			}
			mysql_select_db(_BD, _CONNEXION);
		}
		echo "\t</div>\n";
	}
	echo "</div>\n";
	$compteur++;
	if ($compteur == 4) {
		echo "</td></tr>\n<tr><td class=\"dom_area_box\">";
		$compteur = 0;
	} else {
		echo "</td>\n<td class=\"dom_area_box\">";
	}
	
	return $compteur;
}

/*******************************************************************************
 * 							alert history
 ******************************************************************************/
 
/**
 * fonction recup_alarmes
 * 
 * $tab = tableau contenant la liste des doublons host/service
 * $boite = boite parcourue dans le corps de la fonction
 * $debut = debut de l'intervalle de temps de la recherche
 * $fin = fin de l'intervalle de temps de la recherche
 */

function recup_alarmes(&$tab, $boite, $debut, $fin) {
	$req_ids = "select LBS.id_host, LBS.id_services, S.name as sname, H.name as hname from l_boite_services as LBS inner join hosts as H inner join services as S where id_boite='".$boite."' and S.id=LBS.id_services and H.id=LBS.id_host and LBS.affiche='1'";
	$res_ids = mysql_query($req_ids) or die($req_ids);
	if (mysql_num_rows($res_ids) != 0) {
		while ($row_ids = mysql_fetch_array($res_ids)) {
					$tab_temp = array();
					$tab_temp["host"] = $row_ids["hname"];
					$tab_temp["service"] = $row_ids["sname"];
					$tab[] = $tab_temp;
		}
	}
	$req_enfants = "select id from boite where parent='".$boite."'";
	$res_enfants = mysql_query($req_enfants);
	if (mysql_num_rows($res_enfants) != 0) {
		while ($row_enfants = mysql_fetch_array($res_enfants)) {
			$tab = recup_alarmes(&$tab, $row_enfants["id"], $debut, $fin);
		}
	}
	return $tab;
}

/**
 * fonction affiche_alarmes
 * 
 * $offset = index tableau de la valeur a afficher
 * $tab = tableau associatif des resultats 
 */
function affiche_alarmes($offset, $tab) {
	$affichage = trim($tab[$offset]);
	if ($offset == "timestamp") {
		return date("d/m/y H:i:s", $affichage);
	} else {
		return $affichage;
	}
}

/**
 * fonction nettoie_url
 * 
 * $url = url a nettoyer
 */
function nettoie_url($url) {
	$url = str_replace("&order=asc", "", $url);
	$url = str_replace("&order=desc", "", $url);
	$url = str_replace("?order=asc", "", $url);
	$url = str_replace("?order=desc", "", $url);
	$url = str_replace("&type=timestamp", "", $url);
	$url = str_replace("&type=host", "", $url);
	$url = str_replace("&type=service", "", $url);
	$url = str_replace("&type=commentaire", "", $url);
	$url = str_replace("&type=comm_ack", "", $url);
	$url = str_replace("&type=etat", "", $url);
	return $url;
}

/**
 * fonction nettoyer_url_page
 * 
 * $url = url a nettoyer
 * $page = page courante qu'il faut supprimer dans l'url
 */
function nettoie_url_page($url, $page) {
	$url = str_replace("&page=".$page, "", $url);
	return $url;
}

/**
 * fonction pagination
 * 
 * $page = page courante (affich�e en rouge)
 * $total = nb total d'alarmes 
 */
function pagination($page, $total) {
	$string = "";
	$nb_pages = ceil($total/_NB_ALARM_DETAIL);
	for ($i=1;$i<=$nb_pages;$i++) {
		$tiret = "-";
		$d_red = "";
		$f_red = "";
		if ($i == $nb_pages || $i%10 == 0) {
			$tiret = "";
		}
		if ($i == $page) {
			$d_red = "<span class=\"red\">";
			$f_red = "</span>";
		}
		$string .= "<a href=\"".nettoie_url_page($_SERVER['REQUEST_URI'], $page)."&page=".$i."\"><span class=\"petit\">".$d_red.$i.$f_red."</span></a>".$tiret;
		if ($i%10 == 0) {
			$string .= "<br>";
		}
	}
	return $string;
}


/*******************************************************************************
 * 					partie administration
 ******************************************************************************/
function affiche_select_boite($boite, $rang) {
	$res = mysql_query("select id, name from boite where parent='".$boite."' and statut='0' order by name");
	$prefix = "";
	for ($i=0;$i<$rang*2;$i++) { $prefix .= "-"; }
    while ($row = mysql_fetch_array($res)) {
   		echo "		<option value=\"".$row["id"]."\">".$prefix.$row["name"]."</option>\n";
   		affiche_select_boite($row["id"], $rang+1);
    }
}

function affiche_select_modif_boite($boite, $rang) {
	$res = mysql_query("select id, name from boite where parent='".$boite."' order by name");
	$prefix = "";
	for ($i=0;$i<$rang*2;$i++) { $prefix .= "-"; }
    while ($row = mysql_fetch_array($res)) {
   		echo "		<option value=\"".$row["id"]."\">".$prefix.$row["name"]."</option>\n";
   		affiche_select_modif_boite($row["id"], $rang+1);
    }
}

function affiche_select_boite_reduite($boite, $rang, $boite_curr) {
	//$res = mysql_query("select LBB.id_boite_fille as id, B.name from boite as B inner join l_boite_boite as LBB where LBB.id_boite_mere='".$boite."' and LBB.id_boite_fille=B.id and B.statut='0' order by B.name");
	
	$res = mysql_query("select id, name from boite where parent='".$boite."' and statut='0' order by name");
	$prefix = "";
	for ($i=0;$i<$rang*2;$i++) { $prefix .= "-"; }
    while ($row = mysql_fetch_array($res)) {
    	if (mysql_num_rows(mysql_query("select id from boite where parent='".$row["id"]."' and id='".$boite_curr."'")) == 0) {
    		if ($row["id"] != $boite_curr) {
    			echo "		<option value=\"".$row["id"]."\">".$prefix.$row["name"]."</option>\n";
    			affiche_select_boite_reduite($row["id"], $rang+1, $boite_curr);
    		}
    	} else {
    		echo "		<option value=\"".$row["id"]."\" selected>".$prefix.$row["name"]."</option>\n";
    	}
    }
}

function affiche_form_host($choix_boite, $enfant) {
?>
	<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td valign="top">
				<? echo lang("Boites disponibles"); ?><br>
				<form action="associe_boite.php" method="post"> 
				<select name="hosts[]" multiple size="10">
				<?
					$res = mysql_query("select id, name from hosts order by name");
				    while ($row = mysql_fetch_array($res)) {
				    	if (mysql_num_rows(mysql_query("select id from boite where parent='".$choix_boite."' and name='".$row["name"]."'")) == 0) { 
					   		echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>";
				    	}
				}
			    ?>
		    	</select>
			</td>
			<td align="center">
				<input type="hidden" name="associer" value="1">
				<input type="hidden" name="choix_boite" value="<? echo $choix_boite; ?>">
				<input type="hidden" name="enfant" value="<? echo $enfant; ?>">
				<input type="submit" value=">>">
				</form>
				
				<br><br>
				
				<form action="associe_boite.php" method="post">
				<input type="submit" value="<<">
				<input type="hidden" name="choix_boite" value="<? echo $choix_boite; ?>">
				<input type="hidden" name="enfant" value="<? echo $enfant; ?>">
				<input type="hidden" name="desassocier" value="1">
			</td>
			<td valign="top">
				<? echo lang("Boites associ�es"); ?><br>
				<select name="hosts[]" multiple size="10">
				<?
					$res = mysql_query("select id, name from boite where statut<>'0' and parent='".$choix_boite."' order by name");
				    while ($row = mysql_fetch_array($res)) {
				   		echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>";
				}
			    ?>
			    </form>
			</td>
		</tr>
	</table>
<?
}

function affiche_form_host_dynamique($id_boite, $enfant, $choix_host) {
	echo lang("Host")."<br>";
	echo "	<form action=\"associe_boite.php\" method=\"post\">\n";
	echo "		<select name=\"choix_host\" onChange=\"chgpage(this.form)\">\n";
	echo "			<option value=\"0\">-</option>";
	$res = mysql_query("select id, name from hosts where statut<>'0'");
    while ($row = mysql_fetch_array($res)) {
    	$selected = "";
    	if ($row["id"] == $choix_host) {
    		$selected = "selected";
    	}
   		echo "			<option value=\"associe_boite.php?choix_boite=".$id_boite."&enfant=".$enfant."&choix_host=".$row["id"]."\" ".$selected.">".$row["name"]."</option>\n";
    }
    echo "</select>\n";
    echo "</form>";
}

function affiche_select_services($choix_host, $choix_boite, $enfant) {
?>
	<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td>
				<? echo lang("Services disponibles"); ?><br>
				<form action="associe_boite.php" method="post">
				<select name="services[]" multiple size="10">
				<?
					$res = mysql_query("select L.id_services, S.name from l_services_hosts as L inner join services as S where L.id_hosts='".$choix_host."' and S.id=L.id_services order by name");
				    while ($row = mysql_fetch_array($res)) {
				    	if (mysql_num_rows(mysql_query("select id from l_boite_services " .
				    			"where id_boite='".$choix_boite."' and id_services='".$row["id_services"]."' AND id_host=".$choix_host)) == 0) {
				   			echo "<option value=\"".$row["id_services"]."\">".$row["name"]."</option>";
				    	}
					}
			    ?>
		    	</select>
			</td>
			<td align="center">
				<input type="hidden" name="ajouter" value="1">
				<input type="hidden" name="choix_boite" value="<? echo $choix_boite; ?>">
				<input type="hidden" name="choix_host" value="<? echo $choix_host; ?>">
				<input type="hidden" name="enfant" value="<? echo $enfant; ?>">
				<input type="submit" value="<? echo lang("Ajouter"); ?>">
				</form>
				
				<br><br>
				
				<form action="associe_boite.php" method="post">
				<input type="submit" value="<? echo lang("Supprimer"); ?>">
				<input type="hidden" name="choix_boite" value="<? echo $choix_boite; ?>">
				<input type="hidden" name="choix_host" value="<? echo $choix_host; ?>">
				<input type="hidden" name="enfant" value="<? echo $enfant; ?>">
				<input type="hidden" name="supprimer" value="1">
			</td>
			<td>
				<? echo lang("Services associ�s"); ?><br>
				<select name="services[]" multiple size="10">
				<?
					$req = "select H.name as hname, LSB.id, S.name as sname from services as S inner join hosts as H inner join l_boite_services as LSB " .
							"where LSB.id_boite='".$choix_boite."' and S.id=LSB.id_services and H.id=LSB.id_host order by H.name, S.name";
					$res = mysql_query($req) or die("marche pas : ".$req);
				    while ($row = mysql_fetch_array($res)) {
				   		echo "<option value=\"".$row["id"]."\">".$row["hname"]." / ".$row["sname"]."</option>";
				}
			    ?>
			    </select>
			    </form>
			</td>
		</tr>
	</table>
<?
}

function affiche_form_boite_dynamique($choix_boite, $rang) {
	$res = mysql_query("select id, name from boite where parent='".$choix_boite."' order by name");
	$prefix = "";
	for ($i=0;$i<$rang*2;$i++) { $prefix .= "-"; }
    while ($row = mysql_fetch_array($res)) {
    	$selected = "";
    	if ($row["id"] == $choix_boite) {
    		$selected = "selected";
    	}
   		echo "			<option value=\"affiche_service.php?choix_boite=".$row["id"]."\" ".$selected.">".$prefix.$row["name"]."</option>\n";
   		affiche_form_boite_dynamique($row["id"], $rang+1);
    }
}

function affiche_services($choix_boite) {
?>
	<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td>
				<? echo lang("Services non pris en compte"); ?><br>
				<form action="affiche_service.php" method="post">
				<select name="services[]" multiple size="10">
				<?
				    $res = mysql_query("select S.name, S.id, LBS.id as bid from services as S inner join l_boite_services as LBS where LBS.id_boite='".$choix_boite."' and S.id=LBS.id_services and LBS.affiche=0");
				    while ($row = mysql_fetch_array($res)) {
				   		echo "<option value=\"".$row["bid"]."\">".$row["name"]."</option>";
				}
			    ?>
		    	</select>
			</td>
			<td align="center">
				<input type="hidden" name="ajouter" value="1">
				<input type="hidden" name="choix_boite" value="<? echo $choix_boite; ?>">
				<input type="submit" value="<? echo lang("Ajouter"); ?>">
				</form>
				
				<br><br>
				
				<form action="affiche_service.php" method="post">
				<input type="submit" value="<? echo lang("Supprimer"); ?>">
				<input type="hidden" name="choix_boite" value="<? echo $choix_boite; ?>">
				<input type="hidden" name="supprimer" value="1">
			</td>
			<td>
				<? echo lang("Services pris en compte"); ?><br>
				<select name="services[]" multiple size="10">
				<?
				    $res = mysql_query("select S.name, S.id, LBS.id as bid from services as S inner join l_boite_services as LBS where LBS.id_boite='".$choix_boite."' and S.id=LBS.id_services and LBS.affiche=1");
				    while ($row = mysql_fetch_array($res)) {
				   		echo "<option value=\"".$row["bid"]."\">".$row["name"]."</option>";
				}
			    ?>
			    </form>
			</td>
		</tr>
	</table>
<?
}

function affiche_form_alias_dynamique($choix_boite, $rang) {
	$res = mysql_query("select id, name from boite where parent='".$choix_boite."' order by name");
	$prefix = "";
	for ($i=0;$i<$rang*2;$i++) { $prefix .= "-"; }
    while ($row = mysql_fetch_array($res)) {
    	$selected = "";
    	if ($row["id"] == $choix_boite) {
    		$selected = "selected";
    	}
   		echo "			<option value=\"gestion_alias.php?choix_boite=".$row["id"]."\" ".$selected.">".$prefix.$row["name"]."</option>\n";
   		affiche_form_alias_dynamique($row["id"], $rang+1);
    }
}

function affiche_alias($boite) {
//requete pour choper tous les services du host
$req = "select H.name as hname, S.name as sname, S.id, LBS.id as bid, LBS.alias from services as S inner join hosts as H inner join l_boite_services as LBS where LBS.id_boite='".$boite."' and S.id=LBS.id_services and LBS.id_host=H.id";
$res = mysql_query($req);
if (mysql_num_rows($res) != 0) {
$res2 = mysql_query("select name, alias from boite where id='".$boite."'");
$row2 = mysql_fetch_array($res2);
?>
<form action="gestion_alias.php" method="post">
	<table width="100%" cellpadding="2" cellspacing="0" border="1">
		<tr>
			<td width="50%" align="center">
				<? echo lang("Noeud"); ?><br>		
			</td>
			<td align="center">
				<? echo lang("Alias"); ?><br>
			</td>
		</tr>
		<tr>
			<td width="50%">
				<? echo $row2["name"]; ?><br>		
			</td>
			<td>
				<input type="text" name="alias" value="<? echo $row2["alias"]; ?>" size="30">
				<input type="hidden" name="boite" value="<? echo $boite; ?>">
			</td>
		</tr>
		<tr>
			<td width="50%" align="center">
				<? echo lang("Services"); ?><br>		
			</td>
			<td align="center">
				<? echo lang("Alias"); ?><br>
			</td>
		</tr>
<?
while ($row = mysql_fetch_array($res)) {
?>
		<tr><td><? echo $row["hname"]." / ".$row["sname"]; ?><br></td>
		<td><input type="text" name="alias_<? echo $row["bid"]; ?>" value="<? echo $row["alias"]; ?>" size="30"></td></tr>
<?
}
?>
		<tr><td><input type="hidden" name="inserer" value="1"></td>
		<td><input type="submit" value="Valider"></td></tr>
	</table>
	</form>
<?
} elseif ($boite != "") {
$res = mysql_query("select name, alias from boite where id='".$boite."'");
$row = mysql_fetch_array($res);
?>
<form action="gestion_alias.php" method="post">
	<table width="100%" cellpadding="2" cellspacing="0" border="1">
		<tr>
			<td width="50%" align="center">
				<? echo lang("Noeud"); ?><br>
			</td>
			<td align="center">
				<? echo lang("Alias"); ?><br>
			</td>
		</tr>
		<tr><td><? echo $row["name"]; ?><br></td>
		<td><input type="text" name="alias" value="<? echo $row["alias"]; ?>" size="30"></td></tr>
		<tr><td><input type="hidden" name="inserer_boite" value="1"><input type="hidden" name="boite" value="<? echo $boite; ?>"></td>
		<td><input type="submit" value="Valider"></td></tr>
	</table>
	</form>
<?
}
}

function affiche_select_groupes($id_boite="") {
	$i = 0;
	$tab=array();
	if ($id_boite != "") {
		$res = mysql_query("select id_contactgroups from l_droits where id_boite='".$id_boite."'") or die("marche pas");
		while ($row_tab = mysql_fetch_array($res)) {
			$tab[$i] = $row_tab["id_contactgroups"];
			$i++;
		}
	}
	$res = mysql_query("select id, name from contactgroups");
    while ($row = mysql_fetch_array($res)) {
    	$selected="";
    	if (in_array($row["id"], $tab)) {
    		$selected = " selected";
    	}
		echo "<option value=\"".$row["id"]."\" ".$selected.">".$row["name"]."</option>\n";
	}
}

function affiche_form_poids_dynamique($choix_boite, $rang) {
	$res = mysql_query("select id, name from boite where parent='".$choix_boite."' order by name");
	$prefix = "";
	for ($i=0;$i<$rang*2;$i++) { $prefix .= "-"; }
    while ($row = mysql_fetch_array($res)) {
    	$selected = "";
    	if ($row["id"] == $choix_boite) {
    		$selected = "selected";
    	}
   		echo "			<option value=\"gestion_poids.php?choix_boite=".$row["id"]."\" ".$selected.">".$prefix.$row["name"]."</option>\n";
   		affiche_form_poids_dynamique($row["id"], $rang+1);
    }
}

function affiche_services_poids($choix_boite) {
?>
	<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td width="40%">
				<? echo lang("Services"); ?><br>
				<form action="gestion_poids.php" method="post">
				<select name="services[]" multiple size="10">
				<?
				    $res = mysql_query("select H.name as hname, S.name as sname, S.id, LBS.id as bid, LBS.poids from services as S inner join hosts as H inner join l_boite_services as LBS where LBS.id_boite='".$choix_boite."' and S.id=LBS.id_services and LBS.id_host=H.id");
				    while ($row = mysql_fetch_array($res)) {
				   		echo "<option value=\"".$row["bid"]."\">".$row["hname"]." / ".$row["sname"]."(".$row["poids"].")</option>";
				}
			    ?>
		    	</select>
			</td>
			<td align="center">
				<br><br>
				<input type="hidden" name="choix_boite" value="<? echo $choix_boite; ?>">
				<input type="hidden" name="valider" value="1">
			</td>
			<td valign="top">
				<? echo lang("Poids du service"); ?><br>
				<select name="poids">
			   		<option value="0">0</option>
			   		<option value="1">1</option>
			   		<option value="2">2</option>
			   		<option value="3">3</option>
			   		<option value="4">4</option>
			   		<option value="5">5</option>
			   		<option value="6">6</option>
			   		<option value="7">7</option>
			   		<option value="8">8</option>
			   		<option value="9">9</option>
			   		<option value="10">10</option>
			   	</select>
			   	<br><br>
			    <input type="submit" value="<? echo lang("Valider"); ?>">
			    </form>
			    
			</td>
		</tr>
	</table>
<?
}

function affiche_select_groupe() {
	$res = mysql_query("select * from contactgroups order by name");
	while ($row = mysql_fetch_array($res)) {
		echo "<option value=\"".$row["id"]."\">".$row["name"]."</option>";
	}
}

function associe_host($id_boite, $host) {
	$res = mysql_query("select * from l_services_hosts where id_hosts='".$host."'");
	while ($row = mysql_fetch_array($res)) {
		mysql_query("insert into l_boite_services (id_boite, id_host, id_services, affiche, etat, ackeur) values ('".$id_boite."', '".$host."', '".$row["id_services"]."', '1', '".$row["etat"]."', '".$row["ackeur"]."')");
	}
}

function calcul_etat($choix_boite, $service="", $host="") {
	$max = 0;
	$isBox = 0;
	if ($service == "") {
		if (is_right($choix_boite) || _CALCUL_ETAT_GLOBAL == 1) {
			$res = mysql_query("select id from boite where parent='".$choix_boite."'") or die("marche pas 1");
			if (mysql_num_rows($res) != 0) {
				$isBox = 1;
				while ($row = mysql_fetch_array($res)) {
					$max_tmp = calcul_etat($row["id"]);
					
					// si etat == critical, on coupe car c est l etat le plus grave
					// ameliore les performances
					if ( $max_tmp == 8 ) { return $max_tmp;}
					if ($max_tmp > $max) { $max = $max_tmp; }
				}
			}
			$isTop = mysql_num_rows(mysql_query("select id from boite where id='".$choix_boite."' and parent='0'"));
			$res2 = mysql_query("select etat from l_boite_services where id_boite='".$choix_boite."' and affiche='1'") or die ("marche pas 2");
			if ($isTop == 0 || $isBox == 0) {
			  			  
			  if (mysql_num_rows($res2) != 0) {
					while ($row = mysql_fetch_array($res2)) {
						if ($row["etat"] > $max) {
							$max = $row["etat"];
							// si etat == critical, on coupe car c est l etat le plus grave
							// ameliore les performances
							if ( $max == 8 ) { return $max;}
						}
					}
				}
			}
			if (mysql_num_rows($res) == 0 && mysql_num_rows($res2) == 0) {
				$max = 2;
			}
		}
 	} else {
		$res = mysql_query("select etat from l_boite_services where id_boite='".$choix_boite."' and id_services='".$service."' and id_host=".$host);
		$row = mysql_fetch_array($res);
		$max = $row["etat"];
	}
	return $max;
}

function makeTimestamp($date, $flag){
	$A=substr($date,0,4);
	$M=substr($date,5,2);
	$J=substr($date,8,2);
	if ($flag == "debut") {
		$h="00"; $m="00"; $s="00";
	}
	if ($flag == "fin") {
		$h="23"; $m="59"; $s="59";
	}
	$stamp = mktime($h, $m, $s, $M, $J, $A);
	return $stamp;
}

function makeTimestampSeconde($date, $flag){
	$A=substr($date,0,4);
	$M=substr($date,5,2);
	$J=substr($date,8,2);
	$H=substr($date,11,2);
	$Min=substr($date,4,2);
	$S = "00";
	if ($flag == "fin") {
		$S="59";
	}
	$stamp = mktime($H, $Min, $S, $M, $J, $A);
	return $stamp;
}

function delete_parent($c_group, $boite) {
	$row_p = mysql_fetch_array(mysql_query("select parent from boite where id='".$boite."'"));
	if ($row_p["parent"] != 0) {
		$res = mysql_query("select * from boite where parent='".$row_p["parent"]."'");
		$cut = 0;
		while (($row = mysql_fetch_array($res)) && ($cut == 0)) {
			if (mysql_num_rows(mysql_query("select * from l_droits where id_boite='".$row["id"]."' and id_contactgroups='".$c_group."'")) ) {
				$cut = 1;
			}
		}
		if ($cut == 0) {
			mysql_query("delete from l_droits where id_contactgroups='".$c_group."' and id_boite='".$row_p["parent"]."'") or die("marche pas");
			if ($row_p["parent"] != 0) {
				delete_parent($c_group, $row_p["parent"]);
			}
		}
	}
}

function insert_parent($c_group, $boite) {
	$row = mysql_fetch_array(mysql_query("select parent from boite where id='".$boite."'"));
	if ($row["parent"] != 0) {
		mysql_query("insert into l_droits (id_contactgroups, id_boite) values ('".$c_group."', '".$row["parent"]."')");
		insert_parent($c_group, $row["parent"]);
	}
}

//fonctions damien

// transforme date au format AAAA-MM-JJ hh:mm:ss en timestamp UNIX
function sql2timestamp($sqldate){
	list ($A, $M, $J, $h, $m, $s) = split( '[- :]', $sqldate);
	$time = explode( substr($sqldate,11,17),':');
	return mktime($h, $m, $s, $M, $J, $A);
}

// transforme date au format AAAAMMJJhhmmss en timestamp UNIX
function sqlBloc2timestamp($sqldate){
	$A=substr($sqldate,0,4);
	$M=substr($sqldate,4,2);
	$J=substr($sqldate,6,2);
	$h=substr($sqldate,8,2);
	$m=substr($sqldate,10,2);
	$s=substr($sqldate,12,2);
	return mktime($h, $m, $s, $M, $J, $A);
}

// transforme date au format AAAAMMJJhhmmss en JJ/MM/AAAA hh:mm:ss
function sqlbloc2date($sqldate){
	$A=substr($sqldate,0,4);
	$M=substr($sqldate,4,2);
	$J=substr($sqldate,6,2);
	$h=substr($sqldate,8,2);
	$m=substr($sqldate,10,2);
	$s=substr($sqldate,12,2);
	return " ".$J."/".$M."/".$A." ".$h.":".$m.":".$s." ";
}



function sqltimestamp2date($sqldate){
	$A=substr($sqldate,0,4);
	$M=substr($sqldate,4,2);
	$J=substr($sqldate,6,2);
	$h=substr($sqldate,8,2);
	$m=substr($sqldate,10,2);
	$s=substr($sqldate,12,2);
	return 	$A."-".$M."-".$J." ".$h.":".$m;
}

function date2sqltimestamp($date){
	return str_replace(Array('-',' ',':'), '', $date);
}


?>
