<?php
/*
    html_functions.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Frdric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function html_header($title, $css_file, $rang=1) {
	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";
 	echo "<html>\n";
	echo "<head>\n";
 	echo "<title>".$title."</title>\n";
 	echo "<meta http-equiv=\"Content-Type\" content=\"text/HTML; charset=iso-8859-1\" />\n";
    echo "<link rel=\"stylesheet\" href=\"".$css_file."\" type=\"text/css\" media=\"screen\" />\n";
 	echo "</head>\n\n";
 	echo "<body>\n";
 	echo "<div id='header'>" .
 			"<h1>NaReTo</h1>" .
 			"<h2>Nagios Reporting Tool</h2>" .
 			"<h3>";
 	$dir = "../";
 	if ($rang == 0) {
 		$dir = "";
 	}
 	if (file_exists($dir."include/conf_perso_nareto.txt")) {
 		include("conf_perso_nareto.txt");
 	}
	echo "</h3>" .
 			"</div>\n";
	echo "<div class='line'></div>\n";
 	// container
}

function html_footer() {
	//fermeture container
	echo "<div id='footer'>\n";
	echo "&#169; copyright NaReTo team - Linagora S.A.";
	echo "</div>\n";
	echo "</body>\n";
	echo "</html>\n";	
}

function banniere () {
}

function ariane($fil){
}
?>