<?php
// include 'graphpite/src/Graph.php';
//require_once '../Artichow/BarPlot.class.php';
require_once "../Artichow/LinePlot.class.php";

$graph = new Graph(900, 250);
#$graph->title->set('The title');

$values = array();
$names = array();

include 'agregation.conf.php';
include ("../include/config.php");

$rouge = new Color(250, 110, 110, 0);
$vertInterne = new Color(110, 250, 110, 60);
$vertLigne = new Color(100, 250, 100, 0);


$title = $_GET['title'];
$id = $_GET['id'];
$date1 = $_GET['debut'];
$date2 = $_GET['fin'];
$type = $_GET['type'];
$displaytime =time(); // definit timestamp actuel

//$date1 = date2sqltimestamp($date1);
//$date2 = date2sqltimestamp($date2);

if ( strlen( $date1) == 8 ) {
        $date2 .= "000000";
}
if ( strlen( $date2) == 8 ) {
        $date2 .= "235959";
}

if(strlen($date1)<14) {
	$date1 .='00';
}
if(strlen($date2)<14) {
	$date2 .='00';
}

//echo "debut: ".$date1."<br/>fin: ".$date2."<br/>"; 

#echo $date1." ".sqlBloc2timestamp($date1)."<br>";
#echo $date2." ".sqlBloc2timestamp($date2);

$date1 = sqlBloc2timestamp($date1);
$date2 = sqlBloc2timestamp($date2);



$datas['dispo'] = array();
$datas['time'] = array();

//connexion  la base
//connexion_sql_nareto();

$sql = "SELECT * FROM ".$nom_table[$type]['report']." WHERE downtime=0 AND not_checked=0 AND id=".$id." AND time>".$date1." AND time < ".$date2." order by time";
//echo $sql."<br/>";
$res = mysql_query($sql);
if (mysql_num_rows($res) != 0) {
	while ($row = mysql_fetch_array($res)) {
	$datas['dispo'][] = $row['dispo'];   //echo " - y=".$row['dispo']." ";
	$datas['time'][] = $row['time'];  //echo "  x=".$row['time']."<br/> ";
	$datas['agreg'][] = $row['agreg'];
	}
} else {
	$datas['dispo'][] = 0;
	$datas['time'][] =$displaytime;
	$datas['agreg'][] = '0';
}

 
     

	$previous =0;
	$current = $datas['time'][0];
	@$next = $datas['time'][1];
	$agreg_prev = NULL;
	$agreg = $datas['agreg'][0];
	@$agreg_next = $datas['agreg'][1];

        foreach($datas['dispo'] as $key=>$disp){
				
		if ($key) { 
			$previous = $current;
			$current = $next;
			@$next =$datas['time'][$key+1];
			$agreg_prev = $agreg;
			$agreg = $agreg_next;
			@$agreg_next = $datas['agreg'][$key+1];
		}
		
		$ecart_prev = $current - $previous;
		$ecart_next = $next - $current;
		$data_age = $displaytime - $current;
		
		$vide = FALSE;
		// si l'enregistrement precedent est plus ancien que la periode d'echantillonnage et si l'echantillon est plus ancien que la duree de conservation
		if (($ecart_prev > $period_agreg_m) && ($agreg=='0'||$agreg=='1') && ($agreg_prev!='2')){$vide=TRUE;}
		if (($ecart_prev > $period_agreg_h) && ($agreg=='2'||$agreg=='3') && ($agreg_prev!='4')){ $vide=TRUE;}
		if (($ecart_prev > $period_agreg_j) && ($agreg=='4')){ $vide=TRUE;}
		//if (($ecart_prev > $period_agreg_M) && ($agreg=='4')){ $vide=TRUE;}
		//if($vide) {$values[] = 0; $names[] = date("Y/m/d\nH:i", $current-1);}
		 
		$values[] = $disp/10;
                $names[] = date("Y/m/d\nH:i", $current);
		
		$vide = FALSE;
		// si l'enregistrement precedent est plus ancien que la periode d'echantillonnage et si l'echantillon est plus ancien que la duree de conservation
		if (($ecart_next > $period_agreg_m) && ($agreg=='0'||$agreg=='1')) {$vide=TRUE;}
		if (($ecart_next > $period_agreg_h) && ($agreg=='2'||$agreg=='3') && ($agreg_next>1)) {$vide=TRUE;}
		if (($ecart_next > $period_agreg_j) && ($agreg=='4')&& ($agreg_next>3)) {$vide=TRUE;}
		//if (($ecart_next > $period_agreg_M) && ($data_age < $duree_agreg_M)) { $vide=TRUE;}
		if($vide) {$names[] = date("Y/m/d\nH:i", $current+1); $values[] = 0;}
		
	}
  
    
    
$group = new PlotGroup;
$group->grid->setType(LINE_DASHED);
$group->axis->left->auto(FALSE);
$group->axis->left->setLabelNumber(11);

$group->setYMax(100);
$group->setYmin(0);

$group->axis->left->auto(FALSE);

$group->setPadding(21, 20, 10, 60);




$plot = new LinePlot($values);
$plot->setColor( $vertLigne );//new Color(0, 255, 0, 100));
$plot->setFillColor($vertInterne) ; //new Color(0, 255, 0, 85));

$plot->mark->setType(TICK_OUT);
$plot->mark->setFill(new Green);
$plot->mark->setSize(6);

$group->add($plot);

$group->axis->left->auto(FALSE);
function setYear($value) {
	return $value + 2000;
}


function setK($value) {
	return round($value).'K';
}


$group->axis->bottom->setLabelText($names);
$group->axis->bottom->label->setFont(new TuffyBold(7));
$group->axis->bottom->label->setAngle(45);

$group->legend->add($plot, "Availability", LEGEND_MARK);
$group->legend->setPosition(0.12, 0.70);
$group->legend->shadow->smooth(FALSE);



$group->axis->left->auto(FALSE);
$graph->add($group);

$graph->draw();

?>
