-- phpMyAdmin SQL Dump
-- version 2.6.2-Debian-3sarge1
-- http://www.phpmyadmin.net
-- 
-- Serveur: localhost
-- Généré le : Vendredi 03 Février 2006 à 14:28
-- Version du serveur: 4.1.11
-- Version de PHP: 4.3.10-16
-- 
-- Base de données: `nareto`
-- 

-- --------------------------------------------------------

-- 
-- Structure de la table `autorisations`
-- 

CREATE TABLE autorisations (
  id int(11) NOT NULL auto_increment,
  contactgroup int(11) NOT NULL default '0',
  partie int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `autorisations`
-- 

CREATE TABLE `alert_history` (
  `id` int(11) NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  `host` varchar(100) NOT NULL default '',
  `service` varchar(100) NOT NULL default '',
  `nb_alarmes` int(11) NOT NULL default '0',
  `moy_ack` int(14) NOT NULL default '0',
  `moy_corrige` int(14) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `host` (`host`),
  KEY `service` (`service`),
  KEY `date` (`date`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `boite`
-- 

CREATE TABLE boite (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  alias varchar(100) NOT NULL default '',
  parent int(11) NOT NULL default '-1',
  statut varchar(4) NOT NULL default '0',
  poids int(11) NOT NULL default '1',
  nb_alarmes int(11) NOT NULL default '0',
  moy_ack int(11) NOT NULL default '0',
  moy_corrige int(11) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name),
  KEY parent (parent)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `contactgroups`
-- 

CREATE TABLE contactgroups (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  alias varchar(100) NOT NULL default '',
  members text NOT NULL,
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `contacts`
-- 

CREATE TABLE contacts (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  alias varchar(100) NOT NULL default '',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `hostgroups`
-- 

CREATE TABLE hostgroups (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  alias varchar(100) NOT NULL default '',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `hosts`
-- 

CREATE TABLE `hosts` (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  alias varchar(100) NOT NULL default '',
  statut varchar(4) NOT NULL default '',
  register int(1) NOT NULL default '0',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_boite_services`
-- 

CREATE TABLE l_boite_services (
  id int(11) NOT NULL auto_increment,
  id_boite int(11) NOT NULL default '0',
  id_host int(11) NOT NULL default '0',
  id_services int(11) NOT NULL default '0',
  affiche int(11) NOT NULL default '0',
  etat int(1) NOT NULL default '2',
  ackeur varchar(100) NOT NULL default '',
  ack_comment varchar(100) NOT NULL default '',
  poids int(11) NOT NULL default '1',
  alias varchar(100) NOT NULL default '',
  downtime tinyint(2) NOT NULL default '0',
  not_checked tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id_boite (id_boite),
  KEY id_host (id_host),
  KEY id_services (id_services)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_contactgroups_hostgroups`
-- 

CREATE TABLE l_contactgroups_hostgroups (
  id int(11) NOT NULL auto_increment,
  id_contactgroups int(11) NOT NULL default '0',
  id_hostgroups int(11) NOT NULL default '0',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id_contactgroups (id_contactgroups),
  KEY id_hostgroups (id_hostgroups)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_contacts_contactgroups`
-- 

CREATE TABLE l_contacts_contactgroups (
  id int(11) NOT NULL auto_increment,
  id_contacts int(11) NOT NULL default '0',
  id_contactgroups int(11) NOT NULL default '0',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id_contacts (id_contacts),
  KEY id_contactgroups (id_contactgroups)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_droits`
-- 

CREATE TABLE l_droits (
  id int(11) NOT NULL auto_increment,
  id_contactgroups int(11) NOT NULL default '0',
  id_boite int(11) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id_contactgroups (id_contactgroups),
  KEY id_boite (id_boite)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_hosts_hostgroups`
-- 

CREATE TABLE l_hosts_hostgroups (
  id int(11) NOT NULL auto_increment,
  id_hosts int(11) NOT NULL default '0',
  id_hostgroups int(11) NOT NULL default '0',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id_hosts (id_hosts),
  KEY id_hostgroups (id_hostgroups)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_services_contactgroups`
-- 

CREATE TABLE l_services_contactgroups (
  id int(11) NOT NULL auto_increment,
  id_contactgroups int(11) NOT NULL default '0',
  id_services int(11) NOT NULL default '0',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id_contactgroups (id_contactgroups),
  KEY id_services (id_services)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_services_hosts`
-- 

CREATE TABLE l_services_hosts (
  id int(11) NOT NULL auto_increment,
  id_services int(11) NOT NULL default '0',
  id_hosts int(11) NOT NULL default '0',
  affiche int(11) NOT NULL default '0',
  etat int(1) NOT NULL default '2',
  ackeur varchar(100) NOT NULL default '',
  ack_comment varchar(100) NOT NULL default '',
  `changed` int(1) NOT NULL default '0',
  downtime tinyint(2) NOT NULL default '0',
  not_checked tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id_services (id_services),
  KEY id_hosts (id_hosts)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `l_temp`
-- 

CREATE TABLE l_temp (
  id int(11) NOT NULL auto_increment,
  id_temp int(11) NOT NULL default '0',
  `value` text NOT NULL,
  `type` varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `report_boite`
-- 

CREATE TABLE report_boite (
  `time` int(12) NOT NULL,
  id int(10) unsigned NOT NULL default '0',
  dispo smallint(4) unsigned NOT NULL default '0',
  agreg tinyint(1) unsigned NOT NULL default '0',
  downtime int(11) NOT NULL default '0',
  not_checked int(11) NOT NULL default '0',
  KEY `time` (`time`),
  KEY id (id)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `report_boite_agreg_1h`
-- 

CREATE TABLE report_boite_agreg_1h (
  id int(10) unsigned NOT NULL default '0',
  `time` int(12) NOT NULL,
  dispo int(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (id,`time`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `report_boite_agreg_1j`
-- 

CREATE TABLE report_boite_agreg_1j (
  id int(10) unsigned NOT NULL default '0',
  `time` int(12) NOT NULL,
  dispo int(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (id,`time`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `report_l_b_serv_agreg_1h`
-- 

CREATE TABLE report_l_b_serv_agreg_1h (
  id int(10) unsigned NOT NULL default '0',
  `time` int(12) NOT NULL,
  dispo int(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (id,`time`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `report_l_b_serv_agreg_1j`
-- 

CREATE TABLE report_l_b_serv_agreg_1j (
  id int(10) unsigned NOT NULL default '0',
  `time` int(12) NOT NULL,
  dispo int(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (id,`time`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `report_l_boite_services`
-- 

CREATE TABLE report_l_boite_services (
  `time` int(12) NOT NULL,
  id int(11) unsigned NOT NULL default '0',
  dispo smallint(4) unsigned NOT NULL default '0',
  agreg tinyint(1) unsigned NOT NULL default '0',
  downtime int(11) NOT NULL default '0',
  not_checked int(11) NOT NULL default '0',
  KEY `time` (`time`),
  KEY id (id)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `services`
-- 

CREATE TABLE services (
  id int(11) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  alias varchar(100) NOT NULL default '',
  template varchar(100) NOT NULL default '',
  contactgroup varchar(100) NOT NULL default '',
  register int(1) NOT NULL default '0',
  `changed` int(1) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `suivi_mois`
-- 

CREATE TABLE suivi_mois (
  id int(11) NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  host varchar(100) NOT NULL default '',
  service varchar(100) NOT NULL default '',
  nb_alarmes int(11) NOT NULL default '0',
  moy_ack int(14) NOT NULL default '0',
  moy_corrige int(14) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY host (host),
  KEY service (service),
  KEY `date` (`date`)
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Structure de la table `suivi_semaine`
-- 

CREATE TABLE suivi_semaine (
  id int(11) NOT NULL auto_increment,
  `timestamp` int(12) default NULL,
  jour date NOT NULL default '0000-00-00',
  host varchar(100) NOT NULL default '',
  service varchar(100) NOT NULL default '',
  commentaire varchar(255) NOT NULL default '',
  etat char(1) NOT NULL default '',
  ackeur varchar(100) NOT NULL default '',
  comm_ack varchar(255) NOT NULL default '',
  time_ack int(12) default '0',
  time_corrige int(12) default '0',
  PRIMARY KEY  (id),
  KEY `timestamp` (`timestamp`),
  KEY host (host),
  KEY service (service),
  KEY time_corrige (time_corrige),
  KEY time_ack (time_ack)
) TYPE=MyISAM;
