<?
/*
    parser_cfg.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Frdric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include ("./include/config.php");

function parse($dir_cfg, $file, $table, $champ1, $champ2, $name1, $name2) {
	$tab_cg = array();
	$tab_hn = array();
	if ($file == "services") {
		$f=fopen($dir_cfg.$file.".cfg", "r");
		while ($ligne = fgets($f, 1024)) {
			if (strstr($ligne, "define")) {
				$good_ligne = fgets($f, 1024);
				$ok = 0;
				$name = $cg_tmp = $hn_tmp = "";
				while (!strstr($good_ligne, "}")) {
					if (preg_match('/\s*(\S+)\s+(\S+)/', $good_ligne, $regs) == 1) {
						if ($regs["1"] == "name" && $regs["1"] != "host_name" || $ok == 1) {
							$ok = 1;
							if ($regs["1"] == "name" && $regs["1"] != "host_name") {
								$name = ereg_replace("[^a-zA-Z0-9*_.-]name[^a-zA-Z0-9*_.-]", "", $good_ligne);	
							}
							if ($regs["1"] == "contact_groups") {
								$cg_tmp = ereg_replace("[^a-zA-Z0-9*_.-]contact_groups[^a-zA-Z0-9*_.-]", "", $good_ligne);
							}
							if ($regs["1"] == "host_name") {
								$hn_tmp = ereg_replace("[^a-zA-Z0-9*_.-]host_name[^a-zA-Z0-9*_.-]", "", $good_ligne);
							}
						}
					}				
					$good_ligne = fgets($f, 1024);
				}
				if ($name != "") { 
					if ($hn_tmp != "") { $tab_hn[$name] = $hn_tmp; }
					if ($cg_tmp != "") { $tab_cg[$name] = $cg_tmp; }
				}
			}
		}
		fclose($f);
	}

	$f=fopen($dir_cfg.$file.".cfg", "r");
	$indent = 0;
	while ($ligne = fgets($f, 1024)) {
		$new_id = -1;
		if (strstr($ligne, "define")) {
			$type = trim(str_replace("define", "", $ligne));
			$type = trim(str_replace("{", "", $type));
			$count = 0;
			$var1 = "";
			$var2 = "";
			$good_ligne = fgets($f, 1024);
			$t_services = array();
			$t_services_cg = array();
			$t_hostgroups = array();
			$t_hosts = array();
			$t_contactgroups = array();
			$t1 = $t2 = $t3 = $t4 = $t5 = 0;
			$use = "";
			$register = 0;
			while (!strstr($good_ligne, "}")) {
				if (strstr($good_ligne, "use") && $file == "services") { 
					$use = ereg_replace("[^a-zA-Z0-9*_.-]use[^a-zA-Z0-9*_.-]", "", $good_ligne);
					if ($type == "service") {
						if ($t1 == 0 && isset($tab_hn[$use])) { $t_services[$t1] = $tab_hn[$use]; }
						if ($t2 == 0 && isset($tab_cg[$use])) { $t_services_cg[$t2] = $tab_cg[$use]; }
					}
					
				}
				if (strstr($good_ligne, "register")) {
					$register = 1;
				}
				for ($i=1;$i<=2;$i++) {
					$tmp = "champ".$i;
					$tmp2 = "var".$i;
					if (strstr($good_ligne, $$tmp)) {
						$$tmp2 = trim(str_replace($$tmp, "", $good_ligne));
						$count++;
					}
				}
				if (strstr($good_ligne, "host_name") && $file=="services") {
					$t_services[$t1++] = trim(str_replace("host_name", "", $good_ligne));
				}
				if (strstr($good_ligne, "contact_groups") && $file=="services") {
					$t_services_cg[$t2++] = trim(str_replace("contact_groups", "", $good_ligne));
				}
				if (strstr($good_ligne, "contact_groups") && $file=="hostgroups") {
					$t_hostgroups[$t3++] = trim(str_replace("contact_groups", "", $good_ligne));
				}
				if (strstr($good_ligne, "members") && $file=="hostgroups") {
					$t_hosts[$t4++] = trim(str_replace("members", "", $good_ligne));
				}
				if (strstr($good_ligne, "members") && $file=="contactgroups") {
					$t_contactgroups[$t5++] = trim(str_replace("members", "", $good_ligne));
				}
				$good_ligne = fgets($f, 1024);
			}
			$temp_serv = 0;
			if ($use != "" && $type == "service") {
				if ($var2 == "" && isset($tab_hn[$use])) {
					$var2 = $tab_hn[$use];
				}
				$temp_serv = 1;
				$count = 2;
			}
			if ($count == 2 && ($temp_serv == 1 || $use == "") && $register == 0) {
				$res = mysql_query("select id from ".$table." where ".$name1."='".$var1."'");
		        if (mysql_num_rows($res) == 0) { 
		        	$query = "insert into ";
		        	$query .= $table;
		        	$query .= " (";
		        	for ($i=1;$i<=2;$i++) {
		        		$tmp = "name".$i;
		        		if ($i != 1) { $query .= ", ";}
		        		$query .= $$tmp." ";
		        	}
		        	$query .= ", changed) values ('";
		        	for ($i=1;$i<=2;$i++) {
		        		$tmp = "var".$i;
		        		if ($i != 1) { $query .= "', '";}
		        		$query .= $$tmp." ";
		        	}
		       		$query .= "', '2')";
//		       		echo $query."<br>";
					mysql_query($query);
					$new_id = mysql_insert_id();
		        } else { 
		        	$row = mysql_fetch_array($res);
		        	$id = $row["id"];
		        	$query = "update ";
		        	$query .= $table;
					$query .= " set ";
		        	for ($i=1;$i<=2;$i++) {
		        		$tmp = "name".$i;
		        		$tmp2 = "var".$i;
		        		if ($i != 1) { $query .= "', ";}
		        		$query .= $$tmp."='".$$tmp2;
		        	}
					$query .= "', changed='1' where id='$id'";
//					echo $query."<br>";
					mysql_query($query);
		        	$new_id = $id;
		        }
			}
				if ($new_id != -1) {
					foreach($t_services as $service) {
						create_services_liaisons($service, $new_id);
					}
					foreach($t_services_cg as $service) {
						create_services_cg_liaisons($service, $new_id);
					}
					foreach($t_hostgroups as $service) {
						create_hostgroups_liaisons($service, $new_id);
					}
					foreach($t_hosts as $service) {
						create_hosts_liaisons($service, $new_id);
					}
					foreach($t_contactgroups as $service) {
						create_contactgroups_liaisons($service, $new_id);
					}
				}
		}
	}
	fclose($f);
}

function create_contactgroups_liaisons($tab, $new_id) { 
	// table contacts contactgroups
	$members = array();
	$tab = str_replace(" ","", $tab);
	$members = explode(",", $tab);
	foreach ($members as $unit) {
		$row_mem = mysql_fetch_array(mysql_query("select id from contacts where name='".$unit."'"));
		$res = mysql_query("select id from l_contacts_contactgroups where id_contacts='".$row_mem["id"]."' and id_contactgroups='".$new_id."'");
		$row = mysql_fetch_array($res);
		if (mysql_num_rows($res) == 0) {
			mysql_query("insert into l_contacts_contactgroups (id_contacts, id_contactgroups, changed) values ('".$row_mem["id"]."', '".$new_id."', '1')") or die("marche pas");
		} else {
			mysql_query("update l_contacts_contactgroups set changed='1' where id='".$row["id"]."'") or die("marche pas");
		}
	}
//	echo "On cre le tableau de liaisons contact <-> contactgroups<br>";
}

function create_hostgroups_liaisons($tab, $new_id) {
	// table contactgroups hostgroups
	$contactgroups = array();
	$tab = str_replace(" ", "", $tab);
	$contactgroups = explode(",", $tab);
	foreach ($contactgroups as $unit) {
		$row_mem = mysql_fetch_array(mysql_query("select id from contactgroups where name='".$unit."'"));
		$res = mysql_query("select id from l_contactgroups_hostgroups where id_contactgroups='".$row_mem["id"]."' and id_hostgroups='".$new_id."'");
		$row = mysql_fetch_array($res);
		if (mysql_num_rows($res) == 0) {
			mysql_query("insert into l_contactgroups_hostgroups (id_contactgroups, id_hostgroups, changed) values ('".$row_mem["id"]."', '".$new_id."', '1')") or die("marche pas");
		} else {
			mysql_query("update l_contactgroups_hostgroups set changed='1' where id='".$row["id"]."'") or die("marche pas");
		}
	}
//	echo "On cre le tableau de liaisons contatctgroups <-> hostgroups<br>";
}

function create_services_cg_liaisons($tab, $new_id) {
	// table contactgroups services
	$contactgroups = array();
	$tab = str_replace(" ", "", $tab);
	$contactgroups = explode(",", $tab);
	foreach ($contactgroups as $unit) {
		$row_mem = mysql_fetch_array(mysql_query("select id from contactgroups where name='".$unit."'"));
		$res = mysql_query("select id from l_services_contactgroups where id_contactgroups='".$row_mem["id"]."' and id_services='".$new_id."'");
		$row = mysql_fetch_array($res);
		if (mysql_num_rows($res) == 0) {
			mysql_query("insert into l_services_contactgroups (id_contactgroups, id_services, changed) values ('".$row_mem["id"]."', '".$new_id."', '1')") or die("marche pas");
		} else {
			mysql_query("update l_services_contactgroups set changed='1' where id='".$row["id"]."'") or die("marche pas");
		}
	}
//	echo "On cre le tableau de liaisons contatctgroups <-> services<br>";
}

function create_hosts_liaisons($tab, $new_id) {
	// table hosts hostgroups
	$members = array();
	$tab = str_replace(" ", "", $tab);
	$members = explode(",", $tab);
	foreach ($members as $unit) {
		$row_mem = mysql_fetch_array(mysql_query("select id from hosts where name='".$unit."'"));
		$res = mysql_query("select id from l_hosts_hostgroups where id_hosts='".$row_mem["id"]."' and id_hostgroups='".$new_id."'");
		$row = mysql_fetch_array($res);
		if (mysql_num_rows($res) == 0) {
			mysql_query("insert into l_hosts_hostgroups (id_hosts, id_hostgroups, changed) values ('".$row_mem["id"]."', '".$new_id."', '1')") or die("marche pas");
		} else {
			mysql_query("update l_hosts_hostgroups set changed='1' where id='".$row["id"]."'") or die("marche pas");
		}
	}
//	echo "On cre le tableau de liaisons hosts <-> hostgroups<br>";
}

function create_services_liaisons($tab, $new_id) {
	// table services hosts
	$host_name = array();
	$tab = str_replace(" ", "", $tab);
	$host_name = explode(",", $tab);
	foreach ($host_name as $unit) {
		$row_mem = mysql_fetch_array(mysql_query("select id from hosts where name='".$unit."'"));
		$res = mysql_query("select id from l_services_hosts where id_hosts='".$row_mem["id"]."' and id_services='".$new_id."'");
		$row = mysql_fetch_array($res);
		if (mysql_num_rows($res) == 0) {
			mysql_query("insert into l_services_hosts (id_services, id_hosts, affiche, changed) values ('".$new_id."', '".$row_mem["id"]."', '1', '1')") or die("marche pas");
		} else {
			mysql_query("update l_services_hosts set changed='1' where id='".$row["id"]."'") or die("marche pas");
		}
	}
//	echo "On cre le tableau de liaisons services <-> hosts<br>";
}


function recalcul_liaisons() {
	// au cas ou un nouveau service est ajout dans nagios 
	// on passe en revue les hosts associs a une boite afin d'associer aussi le nouveau service
	$req = "select id from services where changed=2";
//	echo $req."<br>";
	$res = mysql_query($req);
	while ($row = mysql_fetch_array($res)) {
		$req_2 = "select id_hosts from l_services_hosts where id_services='".$row["id"]."'";
//		echo $req_2."<br>";
		$res_2 = mysql_query($req_2);
		while ($row_2 = mysql_fetch_array($res_2)) {
			$req_3 = "select distinct id_boite from l_boite_services where id_host='".$row_2["id_hosts"]."'";
//			echo $req_3."<br>";
			$res_3 = mysql_query($req_3);
			while ($row_3 = mysql_fetch_array($res_3)) {
				$req_4 = "insert into l_boite_services (id_boite, id_host, id_services, affiche) values ('".$row_3["id_boite"]."', '".$row_2["id_hosts"]."', '".$row["id"]."', '1')";
//				echo $req_4."<br>";
				mysql_query($req_4);
			}
		} 
	}

}

function supprime_liaisons() {
	$req = "select id from services where changed='0'";
	$res = mysql_query($req);
	while ($row = mysql_fetch_array($res)) {
		mysql_query("delete from l_boite_services where id_services='".$row["id"]."'");
	}
	$req = "select id from hosts where changed='0'";
	$res = mysql_query($req);
	while ($row = mysql_fetch_array($res)) {
		mysql_query("delete from l_boite_services where id_host='".$row["id"]."'");
	}
}

mysql_query("update contacts set changed='0'");
mysql_query("update contactgroups set changed='0'");
mysql_query("update hosts set changed='0'");
mysql_query("update hostgroups set changed='0'");
mysql_query("update services set changed='0'");

mysql_query("update l_hosts_hostgroups set changed='0'");
mysql_query("update l_services_hosts set changed='0'");
mysql_query("update l_contactgroups_hostgroups set changed='0'");
mysql_query("update l_contacts_contactgroups set changed='0'");
mysql_query("update l_services_contactgroups set changed='0'");

$tab_dir = explode("#", _DIR_CFG);
foreach ($tab_dir as $tab) {
	if (file_exists($tab."contacts.cfg")) { parse($tab, "contacts", "contacts", "contact_name", "alias", "name", "alias"); }
	if (file_exists($tab."contactgroups.cfg")) { parse($tab, "contactgroups", "contactgroups", "contactgroup_name", "alias", "name", "alias"); }
	if (file_exists($tab."hosts.cfg")) { parse($tab, "hosts", "hosts", "host_name", "alias", "name", "alias"); }
	if (file_exists($tab."services.cfg")) { parse($tab, "services", "services", "service_description", "host_name", "name", "alias"); }
	if (file_exists($tab."hostgroups.cfg")) { parse($tab, "hostgroups", "hostgroups", "hostgroup_name", "alias", "name", "alias"); }
}

recalcul_liaisons();

supprime_liaisons();

mysql_query("delete from contacts where changed='0'");
mysql_query("delete from contactgroups where changed='0'");
mysql_query("delete from hosts where changed='0'");
mysql_query("delete from hostgroups where changed='0'");
mysql_query("delete from services where changed='0'");

mysql_query("delete from l_hosts_hostgroups where changed='0'");
mysql_query("delete from l_services_hosts where changed='0'");
mysql_query("delete from l_contactgroups_hostgroups where changed='0'");
mysql_query("delete from l_contacts_contactgroups where changed='0'");
mysql_query("delete from l_services_contactgroups where changed='0'");

echo "Parsage fini!<br><br>";
?>
<input type="button" value="Fermer" onClick="window.close();">