<?php
/*
    associe_boite.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Frdric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/***********************************************************

"Association" dans le menu de la partie administration

page permettant d'associer des hosts ou des services au noeuds crs

***********************************************************/

include ("../include/top.php");

/***********************************************************/
// on verifie que l'utilisateur a l'autorisation de parcourir la page
// si ce n'est pas le cas on le redirige sur la page d'accueil
/***********************************************************/

if (_CONTACT != _ADMIN) {
	if (!is_auto(4)) {?>
		<script language="JavaScript" type="text/javascript">
			document.location = '../index.php';
		</script>
	<?}
}

$choix_host = 0;

/***********************************************************/
// on desassocie un service d'un noeud
// 
/***********************************************************/

if (isset($_POST["supprimer"])) { 
	if (isset($_POST["services"])) {
		$services = $_POST["services"];
		foreach ($_POST["services"] as $service) {
			mysql_query("delete from l_boite_services where id='".$service."'") or die("Suppression d'une association noeud/host dans association");
		}
	}
 	$choix_boite = $_POST["choix_boite"];
 	$choix_host = $_POST["choix_host"];
	$affiche = 2;
	
} else if (isset($_POST["ajouter"])) { 
/***********************************************************/
// on associe un ou plusieurs service(s) a un noeud
// 
/***********************************************************/

	if (isset($_POST["services"])) {
		$services = $_POST["services"];
		$fin = "";
		$virg = "";
		foreach ($_POST["services"] as $service) {
			$req = "select * from l_services_hosts where id_hosts='".$_POST["choix_host"]."' and id_services='".$service."'";
			$res = mysql_query($req) or die("Selection d'informations sur le host dans association");
			$row = mysql_fetch_array($res);
			
			$res = mysql_query("select id from hosts where id='".$_POST["choix_host"]."'") or die("Selection du nom du host dans association");
			$name_host = mysql_fetch_array($res);
	 		$req_insert = "insert into l_boite_services (id_boite, id_host, id_services, affiche, etat, ackeur) values ('".$_POST["choix_boite"]."', '".$name_host["id"]."', '".$service."', '1', '".$row["etat"] ."', '".$row["ackeur"]."')";
	 		mysql_query($req_insert) or die("Cration des services associs dans association");
			$id_boite = mysql_insert_id();
		}
	}
 	$choix_boite = $_POST["choix_boite"];
 	$choix_host = $_POST["choix_host"];
	$affiche = 2;

} else if (isset($_POST["desassocier"])) {
/***********************************************************/
// on desassocie un host d'un noeud
// 
/***********************************************************/

	if (isset($_POST["hosts"])) {
		$hosts = $_POST["hosts"];
		foreach ($_POST["hosts"] as $host) {
			$res = mysql_query("select id from contactgroups");
			while ($row = mysql_fetch_array($res)) {
				mysql_query("delete from l_droits where id_contactgroups='".$row["id"]."' and id_boite='".$host."'") or die("Suppression des droits");
				delete_parent($row["id"], $host);
			}
			mysql_query("delete from boite where id='".$host."'") or die("Suppression d'une association noeud/host dans association");
		}
	}
 	$choix_boite = $_POST["choix_boite"];
	$affiche = 2;

} else if (isset($_POST["associer"])) { 
/***********************************************************/
// on associe un host a un noeud
// 
/***********************************************************/

	if (isset($_POST["hosts"])) {
		$hosts = $_POST["hosts"];
		foreach ($_POST["hosts"] as $host) {
			$res = mysql_query("select * from hosts where id='".$host."'") or die("Selection d'information sur un host dans association");
			$row = mysql_fetch_array($res);
 			mysql_query("insert into boite (name, parent, statut) values ('".$row["name"]."', '".$_POST["choix_boite"]."', '".$row["statut"]."')") or die("Insertion d'une association noeud/host dans association");
 			$id_boite = mysql_insert_id();
 			associe_host($id_boite, $host);
		}
	}
 	$choix_boite = $_POST["choix_boite"];
	$affiche = 2;

} else if (isset($_POST["choix_boite"]) || isset($_GET["choix_boite"])) {
/***********************************************************/
// si aucun des traitements precedents n'est ralis
// on recupere l'id de la boite courante afin de creer le formulaire
// d'association
/***********************************************************/

	if (isset($_POST["choix_boite"])) {
		$choix_boite = $_POST["choix_boite"];
	} else {
		$choix_boite = $_GET["choix_boite"];
	}
	$affiche = 2;
} else {
	$affiche = 1;
}


if (isset($_POST["enfant"])) {
	$enfant = $_POST["enfant"];
} else if (isset($_GET["enfant"])) {
	$enfant = $_GET["enfant"];
}

/***********************************************************/
// on affiche le formulaire de slection de la boite 
// 
/***********************************************************/

if ($affiche == 1) {
?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center">
	<tr>
		<td colspan="2">
			<? echo lang("Association des hosts ou services aux boites"); ?><br><br>
		</td>
	</tr>
	<tr>
		<td valign="top">
			<form action="associe_boite.php" method="post">
			  <? echo lang("Boite"); ?><br>
			  <select name="choix_boite">
			    <?
			    affiche_select_boite(0, 1);
			    ?>
			  </select><br><br>
		</td>
		<td valign="top" width="100%">
			  <input type="radio" name="enfant" value="boites" checked> <? echo lang("Host"); ?><br>
			  <input type="radio" name="enfant" value="services"> <? echo lang("Services"); ?><br>
		</td>
	</tr>
	<tr>
		<td colspan="2">
			  <input type="submit" name="Valider" value="<? echo lang("Valider"); ?>"/>
			</form>
		</td>
	</tr>
</table>
<?
} else if ($affiche == 2){
/***********************************************************/
// formulaire de selection des host ou services a associer
// 
/***********************************************************/

$res = mysql_query("select name from boite where id='".$choix_boite."'") or die("Selection du nom de la boite courante dans association");
$row = mysql_fetch_array($res);
?>
	<table width="95%" cellpadding="0" cellspacing="0" border="0" align="center">
	<tr>
		<td colspan="2">
			<?
			if ($enfant == "boites") { $echo = "hosts"; } else { $echo = $enfant; } 
			echo lang("Association des ").$echo.lang("  la boite ").$row["name"]; ?><br><br>
		</td>
	</tr>
	<tr>
		<td valign="top">
		    <?
	    	if (isset($_GET["choix_host"])) { $choix_host = $_GET["choix_host"]; }
		    if ($enfant == "boites") {
		    	affiche_form_host($choix_boite, $enfant);
		    } else {
		    	affiche_form_host_dynamique($choix_boite, $enfant, $choix_host);
		    }
		    ?>
		  <br><br>
		  		<form action="associe_boite.php" method="get">
		  			<input type="submit" value="<? echo lang("Rinitialiser"); ?>">
		  		</form>
		</td>
		<td valign="top">
			<?
			if ($enfant == "services") {
				affiche_select_services($choix_host, $choix_boite, $enfant);
			} else {
				echo "&nbsp;";
			}
			?>
		</td>
	</tr>
</table>
<?
}

include ("../include/bottom.php");
?>  