;<?php
[Mysql Configuration]
// il est possible d'utiliser host:port pour le nom du serveur
// et le numero de port de MySQL
host          =       localhost
user          =       user
password      =       password
nareto_db     =       nareto
perfparse_db  =       perfparse


[Nagios Configuration]
configuration_file  =       /etc/nagios/nagios.cfg
log_file            =       /var/nagios/nagios.log
statuslog_file      =       /var/nagios/status.log
comment_file        =       /var/nagios/comment.log
archives_path       =       /var/nagios/archives
url_path            =       http://localhost/nagios/

[Nareto Configuration]
// temps de rafraichissement de la page d'affichage 
// des etats dans le temps reel
     // nombre de secondes
refresh             =       60

// variable permettant de calculer l'etat des noeuds 
// en fonction des droits ou pas dans le temps reel
     // 0 => le calcul est effectue avec les droits
     // 1 => le calcul est effectue sans en tenir compte
global_state        =       0

//variable a renseigner pour afficher
     // 0 => les noms de services nagios
     // 1 => les alias renseignes dans la partie admin.
use_alias           =       0

// affichage des liens perfparse?
     // 0 => non
     // 1 => oui
use_perfparse       =       0

// utilisation des noeuds doubles
     // 0 => non
     // 1 => oui
use_doublenode      =       0

// Lien vers nagios lors d'un click sur un indicateur
    // 0 => non
    // 1 => oui
use_nagios          =       0

// utilisateur nagios considere comme l'administrateur 
// nareto. Il accede a tout meme si son contactgroup
// n'a pas les droits.
// Il peut y avoir plusieurs admins:
//  admin = nagiosadmin,theboss,jdoe
admin               =       nagiosadmin

// Mise en base de donnees des alertes SOFT.
// Dans le cas contraire, on ne met en base de donnees
// que les alarmes HARD
soft_alarm          =       0

// Nombre d alarme affichees dans le module 
// Alert::History pour les noeuds
nb_alarm            =       12

// Nombre d alarme affichees dans le module 
// Alert::History dans le detail avant de faire 
// une nouvelle page
nb_alarm_detail     =       50
;?>
