<?
/**
    config.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Frdric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

$ini_array = parse_ini_file(dirname(__FILE__)."/config.ini.php", TRUE);


/********************************************************/
/**                    config mysql                     */
/********************************************************/
// configuration base de donnes
/*initialisation des variables pour les connections &agrave; la base de donn&eacute;e */
	define ("_SERVEUR", $ini_array["Mysql Configuration"]["host"]);
	define ("_UTILISATEUR", $ini_array["Mysql Configuration"]["user"]);
	define ("_PWD", $ini_array["Mysql Configuration"]["password"]);
	define ("_BD", $ini_array["Mysql Configuration"]["nareto_db"]);
	define ("_BD_PERFPARSE", $ini_array["Mysql Configuration"]["perfparse_db"]);
	
/*connection aux serveurs php et mysql*/
	$connexion=mysql_connect (_SERVEUR, _UTILISATEUR, _PWD);
	define ("_CONNEXION", $connexion);
	mysql_select_db(_BD, _CONNEXION);

/*******************************************************/
/**                    config lang                     */
/*******************************************************/

/* la configuration de la langue se fait dans lang/config.php */

/*******************************************************/
/**            config path fichiers nagios             */
/*******************************************************/
// fichier nagios.cfg (chemin/vers_/fichier/nagios.cfg)
	define ("_PATH_NAGIOS_CFG", $ini_array["Nagios Configuration"]["configuration_file"] );
	
// fichiers cfg (plusieurs possibles a separes par #)
//	define ("_DIR_CFG", "/usr/local/demo/nagios/etc/");
	
// fichier nagios.log (ou autre fichier pour les alarmes)
	define ("_DIR_NAGIOS",$ini_array["Nagios Configuration"]["log_file"] );
	
// fichier status.log
	define ("_DIR_STATUS", $ini_array["Nagios Configuration"]["statuslog_file"]);
	
// fichier comment.log
	define ("_DIR_COMMENT", $ini_array["Nagios Configuration"]["comment_file"]);



/*******************************************************/
/**       config table sql pour le reporting           */
/*******************************************************/
// noms des tables de reporting en fct du type d'objet (boite  ou service)
global $nom_table;
 $nom_table = array('boite'=>array('report'=>'report_boite', 'agreg1h'=>'report_boite_agreg_1h', 'agreg1j'=>'report_boite_agreg_1j'),
				    'service'=>array('report'=>'report_l_boite_services', 'agreg1h'=>'report_l_b_serv_agreg_1h', 'agreg1j'=>'report_l_b_serv_agreg_1j')
  ); 


/*******************************************************/
/**  config chemin vers nagios pour les liens directs  */
/*******************************************************/
//path nagios pour le lien direct des services nareto vers les services correspondants nagios
//if ( $_SERVER['SERVER_PORT'] == 443 ) {
//        $nagios_path = "https://". $_SERVER['SERVER_NAME'] ."/nagios";
//} else {
//        $nagios_path = "http://". $_SERVER['SERVER_NAME'] ."/nagios";
//}
define ("_NAGIOS_PATH", $ini_array["Nagios Configuration"]["url_path"]);

/*******************************************************/
/**     tableau des differents etats possibles          */
/*******************************************************/
$css_etats=array(null,'ok','pending','unknown_ack','warning_ack','critical_ack','unknown','warning','critical');

/*******************************************************/
/**              variables de config                   */
/*******************************************************/
//format des timestamp mysql
//	define ("_TIMESTAMP", "0000-00-00 00:00:00");

//temps de rafraichissement de la page d'affichage des tats dans le temps rel
	// nombre de secondes
	define ("_REFRESH", $ini_array["Nareto Configuration"]["refresh"]);	

//variable permettant de calculer l'etat des noeuds en fonction des droits ou pas dans le temps reel
	// 0 => le calcul est effectue avec les droits
	// 1 => le calcul est effectue sans tenir compte des droits
	// $v_calcul_etat_global = 0;
	define ("_CALCUL_ETAT_GLOBAL", $ini_array["Nareto Configuration"]["global_state"]);

//variable a renseigner pour afficher
	// 0 => les noms de services nagios
	// 1 => les alias renseignes dans la partie administration
	define ("_AFFICHE_ALIAS", $ini_array["Nareto Configuration"]["use_alias"]);
	
	if (_AFFICHE_ALIAS == 1) {
		define ("AFF_ALIAS", "alias");
	} else {
		define ("AFF_ALIAS", "name");
	}

// affichage des liens perfparse?
	// 0 => non
	// 1 => oui
	define ("_PERFPARSE", $ini_array["Nareto Configuration"]["use_perfparse"]);

// utilisation des noeuds doubles
	// 0 => non
	// 1 => oui
	define ("_DOUBLE_NOEUD", $ini_array["Nareto Configuration"]["use_doublenode"]);

// affichage des liens nagios?
	// 0 => non
	// 1 => oui
	define ("_NAGIOS", $ini_array["Nareto Configuration"]["use_nagios"]);

// nombre d'alarmes affiches par dfaut dans alert::history
	define ("_NB_ALARM", $ini_array["Nareto Configuration"]["nb_alarm"]);

// nombre d'alarmes affiches dans la page dtail de alert::history
	define ("_NB_ALARM_DETAIL", $ini_array["Nareto Configuration"]["nb_alarm_detail"]);

// utilisateur nagios considr comme l'administrateur nareto. il accede a tout meme si son contactgroup n'a pas les droits
	define ("_ADMIN", $ini_array["Nareto Configuration"]["admin"]);

define ("_CONTACT", $_SERVER['REMOTE_USER']);

include ("fonctions.php");

?>
