<?php
// include("graphpite/src/Graph.php");
require_once "../Artichow/Pie.class.php";
$value=$_GET['value'];
$title=$_GET['title'];
    
$otherValue= 100.0 - $value;

// create the graph
$graph =& new Graph(200, 150);

$rouge = new Color(250, 110, 110, 0);
$vert = new Color(150, 250, 150, 0);

$graph->setAntiAliasing(FALSE);

if ( $value < 0.3 ) {
  $values = array( $otherValue);
  $colors = array(
                  $rouge
                  );
}
else if ($value == 100 ) {
  $values = array( $value);
  $colors = array(
                  $vert
                  );
}
else {
$values = array( $value, $otherValue);

$colors = array(
                $vert,
                $rouge
);
}

// c'est un PieChart 
$plot = new Pie($values, $colors);
// on centre le piechart et on definit la taille du disque
$plot->setCenter(0.5, 0.5);
$plot->setSize( 0.6, 0.75);
$plot->set3D(10);
$plot->explode(array(1 => 15));

// on augmente la precision des valeurs affichees
// et on rapproche les labels 
$plot->setLabelPrecision(1);
$plot->setLabelPosition(5);

// on cache la legende car :
//    - elle se place tres mal
//    - elle prend trop de place
//    - c'est suffisament parlant pour ne pas mettre de legende
$plot->legend->hide();

// la couleur des traits entre les "quartiers" du piechart
// Note Cedric :  adapter en fonction des couleurs $colors
// $plot->setBorder(new Black);


$graph->add($plot);
$graph->draw();



?>