<?php
/*
    display_image.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Fr�d�ric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

extract($_GET, EXTR_OVERWRITE);
include ("../include/config.php");

function seconde2heure($secondes) {
	$heure = floor($secondes/3600);
	$reste = $secondes%3600;
	$minute = floor($reste/60);
        $secondes = $secondes%60;
	if ($minute < 10) {
		$minute = "0".$minute;
	}
        
	if ($secondes < 10) {
          $secondes = "0".$secondes;
	}
	return $heure."h".$minute."m".$secondes."";
}

function search_suivi($boite , &$tab1, &$tab2, $type, $dateDebut, $dateFin) {
	$row = mysql_fetch_array(mysql_query("select name from boite where id='".$boite."'"));
	$req = "select * from suivi_mois where host = '".$row["name"]."'and date <= '".$dateFin."' and date >= '".$dateDebut."' order by date";
	$res = mysql_query($req);
	$nb_con = 0;
	while ($row = mysql_fetch_array($res)) {
		$nb_con++;
                $req_affiche = "select LBS.id  from l_boite_services as LBS inner join services as S where LBS.id_boite='".$boite."' and S.name=\"".$row["service"]."\" and S.id=LBS.id_services and LBS.affiche='1'";
			if (mysql_num_rows(mysql_query($req_affiche)) != 0) {
				$tab1[] = substr($row["date"], 5, 5);
				if ($type == 1) {
					$tab2[] = $row["nb_alarmes"];
				}
				if ($type == 2) {
					$tab2[] = floor($row["moy_ack"]);
				}
				if ($type == 3) {
					$tab2[] = floor($row["moy_corrige"]);
				}
			}
        }
	$req = "select id from boite where parent='".$boite."'";
	$res = mysql_query($req);
	while ($row = mysql_fetch_array($res)) { 
		search_suivi($row["id"], &$tab1, &$tab2, $type, $dateDebut, $dateFin);
	}
}

//require_once "../Artichow/LinePlot.class.php";
require_once "../Artichow/BarPlot.class.php";
require('./panachart.php');
$value = array();
$name = array();
$tmp1 = array();
$tmp2 = array();
if ($id == 1) {
	$titre = lang("Nombre d'alarmes");
	$type_graphe = 'bar';
	$comm1 = lang("Date");
	$comm2 = lang("Nombre d'alarmes");
	search_suivi($choix_boite, $tmp1, $tmp2, 1, $dateDebut, $dateFin);
}
if ($id == 2) {
	$titre = lang("Temps moyen de prise en charge");
	$type_graphe = 'area';
	$comm1 = lang("Date");
	$comm2 = lang("Temps moyen de prise en charge (s)");
	search_suivi($choix_boite, $tmp1, $tmp2, 2, $dateDebut, $dateFin);
}
if ($id == 3) {
	$titre = lang("Temps moyen de correction");
	$type_graphe = 'area';
	$comm1 = lang("Date");
	$comm2 = lang("Temps moyen de correction (s)");
	search_suivi($choix_boite, $tmp1, $tmp2, 3, $dateDebut, $dateFin);
}

array_multisort ($tmp1, $tmp2);


$value_val = 0;
$jour_curr = "";
$count_elt = 0;
foreach ($tmp1 as $key=>$jour) {
	if ($jour_curr != $jour) {
		if ($jour_curr != "") {
			$name[] = $jour_curr;
			if ($id == 2 || $id == 3) {
				$value_val = $value_val/$count_elt;
			}
//			$value[] = seconde2heure($value_val);
			$value[] = $value_val;
		}
		$jour_curr = $jour;
		$nb_alarm = 0;
		$moy_ack = 0;
		$moy_corrige = 0;
		$count_elt = 0;
		$value_val = 0;		
	}
	$value_val += $tmp2[$key];
	$count_elt++;
}

if ($jour_curr != "") {
	$name[] = $jour_curr;
	if ($id == 2 || $id == 3) {
		$value_val = $value_val/$count_elt;
	}
//	$value[] = seconde2heure($value_val);
	$value[] = $value_val;
}

if (count($name) == 0) {
  # l'image ne contient aucune donnee, on envoie 
  # donc une image vide pre-enregistree
  header("Content-type: image/png");

  $image = new FileImage("./image_vide.png");
  $image->setSize(350,200);
  $image->send();
  
} 
else if (count($name) < 1) {
  # l'image ne contient aucune donnee, on envoie 
  # donc une image vide pre-enregistree
  header("Content-type: image/png");

  $image = new FileImage("./image_vide.png");
  $image->setSize(350,200);
  $image->send();
} 
else {
  // header('Content-Type: image/png');
  
  $graph = new Graph(350, 200);
  $graph->setAntiAliasing(FALSE);
  
  
# ici, on met en place des graphiques a barres (histogramme)
    $plot = new BarPlot($value);
    $plot->setSpace(4, 4, 10, 0);
    if ($id == 1) {
       $plot->setPadding(30, 15, 10, 40);
    }
    else {
      $plot->setPadding(50, 15, 10, 40);
    }
    
    $plot->title->set($titre);
    $plot->title->setFont(new TuffyBold(11));
    $plot->title->border->show();
    $plot->title->setBackgroundGradient(new LinearGradient(new Color(250, 250, 250, 30), new Color(239, 140, 0, 60), 0));
    $plot->title->setPadding(4, 4, 4, 4);
    $plot->title->move(10, 190);
    
    
# axe X, les dates
    $plot->xAxis->setLabelText($name);
    $plot->xAxis->label->setFont(new TuffyBold(8));

# on ajoute les points au label pour avoir les valeurs au dessus
# des barres
 $plot->label->set($value);
 # si c'est le cas de la prise en charge ou du temps de correction
# on transforme les secondes en HH::MM::SS
 if ( $id == 2 || $id == 3) {
   $plot->label->setCallBackFunction('seconde2heure');
 }
 $plot->label->move(0, -7);
 $plot->label->setBackgroundGradient(new LinearGradient(new Color(250, 250, 250, 30), new Color(200, 200, 200, 0), 0));
 $plot->label->border->setColor(new Color(20, 20, 20, 20));
 $plot->label->setPadding(3, 1, 1, 0);
 
# Note Cedric : il est possible de changer la couleur 
# selon une nouvelle charte graphique ; je  ne suis pas le
# meilleur dans ce domaine ;-)
#  $plot->barBorder->setColor(new Color(0, 0, 150, 20));
  
  $plot->setBarColor(new Color(80, 105, 190, 40));
#new Color(230,230,230));

$plot->barShadow->setSize(3);
	$plot->barShadow->setPosition(SHADOW_RIGHT_TOP);
	$plot->barShadow->setColor(new Color(180, 180, 180, 60));
	$plot->barShadow->smooth(TRUE);
  
# ceci permet de "renfoncer" le graph et de donner un
# style plus sympa
  $graph->shadow->setSize(4);
  $graph->shadow->setPosition(SHADOW_LEFT_TOP);
  $graph->shadow->smooth(TRUE);
  $graph->shadow->setColor(new Color(160, 160, 160));

  $graph->setBackgroundGradient(new LinearGradient(
		new Color(200, 200, 200),
		new Color(255, 255, 255),
		0
                ));
#

# dans le cas de la prise en charge et de temps de correction
# on transforme en HH::MM::SS
if ($id == 2 || $id == 3) {
  $plot->yAxis->setLabelNumber(5);
  $plot->yAxis->label->setCallbackFunction('seconde2heure');

}
 
  $graph->add($plot);
  $graph->draw();
  
}
?>
